/*
 * Textarea
 *
 * Index
 * - Input
 * - Textarea
 * - Label
 * - Sizes
 * - Error
 * - Helper
 */

:host {
  position: relative;
  display: block;
  margin-bottom: 1rem;
  font-family: var(--road-font, sans-serif);
  color: var(--road-on-surface);
}

/* INPUT
 -------------------- */

.form-control {
  box-sizing: border-box;
  display: block;
  width: 100%;
  height: 3rem;
  padding: 0.75rem 1rem 0;
  margin: 0;
  font-size: var(--road-body-medium);
  color: var(--road-on-surface);
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: 0.25rem;
  box-shadow: none;
  appearance: none;
}

/**
 * Placeholder
 */

.form-control::placeholder {
  color: var(--road-on-surface-extra-weak);
  opacity: 1;
}

/**
 * Hover state
 */

@media (hover: hover) {

  .form-control:not(:disabled):hover {
    border-color: var(--road-input-outline-variant);
  }
}

/**
 * Focus state
 */

.form-control:focus ~ .form-label,
.form-control[required]:valid ~ .form-label,
.form-control.has-value ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}

.form-control:placeholder-shown ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}

/* stylelint-disable */

/* IE FIX */

.form-control:-ms-input-placeholder ~ .form-label {
  transform: scale(0.625) translateY(-0.625rem);
}
/* stylelint-enable */

.form-control:not(:disabled):focus {
  border-color: var(--road-input-outline-variant);
}

/**
 * Disabled state
 */

.form-control:disabled,
.form-control[readonly] {
  color: var(--road-on-surface-weak);
  cursor: not-allowed;
  background: var(--road-surface-disabled);
  opacity: 1;
}

/* TEXTAREA
 -------------------- */

.textarea-control {
  height: auto;
  padding-top: 1rem;
  padding-bottom: 0.5rem;
  line-height: 1.5;
}

.textarea-control.no-resize {
  resize: none;
}

/* LABEL
 -------------------- */

.form-label {
  position: absolute;
  top: 0.75rem;
  left: 1rem;
  display: block;
  font-size: var(--road-body-medium);
  line-height: 1.5;
  color: var(--road-on-surface-weak);
  pointer-events: none;
  transition: transform 200ms cubic-bezier(0, 0, 0.2, 1) 0ms;
  transform-origin: 0 0;
}

/* SIZES
 -------------------- */

:host(.input-xl) {
  --height: 3.5rem;
}

:host(.input-xl) .form-control {
  padding: 1.5rem 1rem 0.5rem;
}

:host(.input-xl) .form-label {
  top: 1rem;
}

:host(.input-xl) .form-control:focus ~ .form-label,
:host(.input-xl) .form-control[required]:valid ~ .form-label,
:host(.input-xl) .form-control.has-value ~ .form-label,
:host(.input-xl) .form-control[type="date"] ~ .form-label,
:host(.input-xl) .form-control[type="time"] ~ .form-label {
  width: 100vw;
  transform: scale(0.75) translateY(-0.625rem);
}

:host(.input-xl) .form-control:placeholder-shown ~ .form-label {
  width: 100vw;
  transform: scale(0.75) translateY(-0.625rem);
}


/* ERROR
 -------------------- */

.invalid-feedback {
  display: none;
  width: 100%;
  margin-top: 0.5rem;
  font-size: var(--road-helper-medium);
  color: var(--road-on-danger-surface);
}

.form-control.is-invalid,
.was-validated .form-control:invalid {
  border-color: var(--road-danger-outline);
}

.form-control.is-invalid ~ .invalid-feedback,
.was-validated .form-control:invalid ~ .invalid-feedback {
  display: block;
}

/* HELPER
 -------------------- */

.helper {
  margin-top: 0.5rem;
  font-size: var(--road-helper-medium);
  color: var(--road-on-surface-weak);
}
